﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace vcsharp_spi_demo_v1._0
{
    public partial class SPIDemo : Form
    {
        const int SqauerWave = 0;
        const int SineWave = 1;
        const int Sawtooth = 2;
        const int TriangleWave = 3;
        IntPtr  spiHandle = IntPtr.Zero;                                            ///< SPI library handle
        int     loopCounter = 0;                
        int     waveform = 0;                                                              
        bool    flag = true;                                                        ///< flag only for square wave generation
        Byte[] spiDataFrame = new Byte[2];                                               ///< Transmit buffer
        /// Data values to generate sine wave
        Byte[] sineWave = new Byte[128] {0x63, 0x38, 0x2B, 0x39, 0xF1, 0x39, 0xB1, 0x3A, 0x6A, 0x3B, 0x1C, 0x3C, 0xC3, 0x3C, 0x5E, 0x3D, 0xEC, 0x3D, 0x6C, 0x3E, 0xDB, 0x3E, 
                              0x3A, 0x3F, 0x87, 0x3F, 0xC1, 0x3F, 0xE8, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xE8, 0x3F, 0xC1, 0x3F, 0x87, 0x3F, 0x3A, 0x3F, 0xDB, 0x3E, 
                              0x6C, 0x3E, 0xEC, 0x3D, 0x5E, 0x3D, 0xC3, 0x3C, 0x1C, 0x3C, 0x6A, 0x3B, 0xB1, 0x3A, 0xF1, 0x39, 0x2B, 0x39, 0x63, 0x38, 0x9B, 0x37,
                              0xD3, 0x36, 0x0D, 0x36, 0x4D, 0x35, 0x94, 0x34, 0xE2, 0x33, 0x3B, 0x33, 0xA0, 0x32, 0x12, 0x32, 0x92, 0x31, 0x23, 0x31, 0xC4, 0x30, 
                              0x77, 0x30, 0x3d, 0x30, 0x16, 0x30, 0x02, 0x30, 0x02, 0x30, 0x16, 0x30, 0x3D, 0x30, 0x77, 0x30, 0xC4, 0x30, 0x23, 0x31, 0x92, 0x31,
                              0x12, 0x32, 0xA0, 0x32, 0x3B, 0x33, 0xE2, 0x33, 0x94, 0x34, 0x4D, 0x35, 0x0D, 0x36, 0xD3, 0x36, 0x9B, 0x37};
        ///< Data values to generate sawtooth wave
        Byte[] sawWave = new Byte[68] {0x00, 0x30, 0x7D, 0x30, 0xFA, 0x30, 0x77, 0x31, 0xF4, 0x31, 0x71, 0x32, 0xEE, 0x32, 0x6B, 0x33, 0xE8, 0x33, 0x65, 0x34, 0xE2, 0x34, 0x5F,
                              0x35, 0xDC, 0x35, 0x59, 0x36, 0xD6, 0x36, 0x53, 0x37, 0xD0, 0x37, 0x4D, 0x38, 0xCA, 0x38, 0x47, 0x39, 0xC4, 0x39, 0x41, 0x3A, 0xBE, 0x3A, 
                              0x3B, 0x3B, 0xB8, 0x3B, 0x35, 0x3C, 0xB2, 0x3C, 0x2F, 0x3D, 0xAC, 0x3D, 0x29, 0x3E, 0xA6, 0x3E, 0x23, 0x3F, 0xA0, 0x3F, 0x00, 0x30};
        ///< Data values to generate triangle wave
        Byte[] triangleWave = new Byte[130] {0x00, 0x30, 0x7D, 0x30, 0xFA, 0x30, 0x77, 0x31, 0xF4, 0x31, 0x71, 0x32, 0xEE, 0x32, 0x6B, 0x33, 0xE8, 0x33, 0x65, 0x34, 0xE2, 0x34,
                              0x5F, 0x35, 0xDC, 0x35, 0x59, 0x36, 0xD6, 0x36, 0x53, 0x37, 0xD0, 0x37, 0x4D, 0x38, 0xCA, 0x38, 0x47, 0x39, 0xC4, 0x39, 0x41, 0x3A,
                              0xBE, 0x3A, 0x3B, 0x3B, 0xB8, 0x3B, 0x35, 0x3C, 0xB2, 0x3C, 0x2F, 0x3D, 0xAC, 0x3D, 0x29, 0x3E, 0xA6, 0x3E, 0x23, 0x3F, 0xA0, 0x3F, 
                              0x23, 0x3F, 0xA6, 0x3E, 0x29, 0x3E, 0xAC, 0x3D, 0x2F, 0x3D, 0xB2, 0x3C, 0x35, 0x3C, 0xB8, 0x3B, 0x3B, 0x3B, 0xBE, 0x3A, 0x41, 0x3A, 
                              0xC4, 0x39, 0x47, 0x39, 0xCA, 0x38, 0x4D, 0x38, 0xD0, 0x37, 0x53, 0x37, 0xD6, 0x36, 0x59, 0x36, 0xDC, 0x35, 0x5F, 0x35, 0xE2, 0x34,
                              0x65, 0x34, 0xE8, 0x33, 0x6B, 0x33, 0xEE, 0x32, 0x71, 0x32, 0xF4, 0x31, 0x77, 0x31, 0xFA, 0x30, 0x7D, 0x30, 0x00, 0x30};
        ///< Data values to generate square wave
        Byte[] squareWave   = new Byte[4] { 0xd9, 0x34, 0x00, 0x30 };                    
        public SPIDemo()
        {
            InitializeComponent();
            spiHandle = spi.Spi_Init("SPI2");                                                               ///< Init SPI library 
            if (spiHandle == IntPtr.Zero)
            {
                MessageBox.Show("Error initializing the SPI Library");
            }
            spi.Spi_SetConfigInt(spiHandle, "SpiMode", 0, TdxCommon.ParamStorageType.StoreVolatile);        ///< Set SPI on Mode 0
            spi.Spi_SetConfigInt(spiHandle, "BitRateHz", 26000, TdxCommon.ParamStorageType.StoreVolatile);  ///< Set SPI clock 26000 Lhz
            if (!spi.Spi_Open(spiHandle))
            {
                MessageBox.Show("Failed to open SPI");
            }
            spi.Spi_SetConfigInt(spiHandle, "ioCS", 86, TdxCommon.ParamStorageType.StoreVolatile);          ///< Set Chip Select pin sodimm 86
            cmbWaveform.SelectedIndex = 0;                      
        }
        /// <summary>
        /// Set Button event to start generating waveform procedure of selected wave
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SetWaveform(object sender, EventArgs e)                                                ///< When Set Button is Pressed
        {
            loopCounter = 0;                                                                                ///< reset the variables to default value
            flag = true;
            waveform = cmbWaveform.SelectedIndex;                                                           ///< Set the Count equal to index of selected item in Combo-box
            if (waveform == 0)
                tmrLoop.Interval = 400;                                                                     ///< Set timer Interval equal to 400ms
            else
                tmrLoop.Interval = 1;                                                                       ///< Set timer interval equal to 1ms
            tmrLoop.Enabled = true;                                                                         ///< Start timer
        }
        /// <summary>
        /// Combobox event when index change to provide correct image for reference of selected wave
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CmbIndexChangeEvent(object sender, EventArgs e)                                        ///< When selcted waveform change, then change image also
        {
            string myDir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            switch (cmbWaveform.SelectedIndex)
            {
                case SqauerWave:
                    imageBox.Image = new Bitmap(myDir + "\\Square_wave.png");                               ///< Display Image for Square wave
                    break;
                case SineWave:
                    imageBox.Image = new Bitmap(myDir + "\\Simple_sine.png");                               ///< Display Image for sine wave                      
                    break;
                case Sawtooth:
                    imageBox.Image = new Bitmap(myDir + "\\Sawtooth_wave.png");                             ///< Display image for sawtooth wave
                    break;
                case TriangleWave:
                    imageBox.Image = new Bitmap(myDir + "\\Triangle_wave.png");                             ///< Display image for triangle wave
                    break;
            }
        }
        /// <summary>
        /// Timer event to send digital waveform data continously to DAC chip over SPI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void GenerateWaveform(object sender, EventArgs e)                                           ///< Timer Event
        {
            int size = 0;
            Byte[] spiData = new Byte[4]{0,0,0,0};
            switch (waveform)
            {
                case SqauerWave:                                                                            ///< For Square Wave
                    if (flag == true)
                    {
                        spiDataFrame[1] = squareWave[0];
                        spiDataFrame[0] = squareWave[1]; 
                        flag = false;
                    }
                    else
                    {
                        spiDataFrame[1] = squareWave[2];
                        spiDataFrame[0] = squareWave[3];
                        flag = true;
                    }
                    unsafe
                    {
                        fixed (byte* for_Casting_Intptr_to_Byte = spiDataFrame)
                        {
                            spi.Spi_Write(spiHandle, (IntPtr)for_Casting_Intptr_to_Byte, 2);
                        }
                    }
                    break;
                case SineWave:                                                                              ///< For Sine Wave
                    size = sineWave.Length;
                    Array.Resize(ref spiData, size);
                    spiData = sineWave;
                    break;
                case Sawtooth:                                                                              ///< For Sawtooth Wave
                    size = sawWave.Length;
                    Array.Resize(ref spiData, size);
                    spiData = sawWave;
                    break;
                case TriangleWave:                                                                          ///< For Triangle Wave
                    size = triangleWave.Length;
                    Array.Resize(ref spiData, size);
                    spiData = triangleWave;
                    break;
                default:
                    break;
            }
            for (loopCounter = 0; loopCounter < size; loopCounter = loopCounter + 2)
            {
                spiDataFrame[1] = spiData[loopCounter];
                spiDataFrame[0] = spiData[loopCounter + 1];
                unsafe
                {
                    fixed (byte* for_Casting_Intptr_to_Byte = spiDataFrame)
                    {
                        spi.Spi_Write(spiHandle, (IntPtr)for_Casting_Intptr_to_Byte, 2);
                    }
                }
            }
        }
        /// <summary>
        /// Demo closing event di-init SPI library
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExitAction(object sender, CancelEventArgs e)
        {
            spi.Spi_Close(spiHandle);
            spi.Spi_Deinit(spiHandle);                                                                       ///< De-Initializes SPI
        }
    }
}